// Mimicking Robot Arm
// Vinitha Ranganeni & Nina Lin
// 16-223 Final Project

// import libraries
#include <Servo.h>

// Define constant values and global variables
int POT_PIN_HAND = A1;
int POT_PIN_UPPER = A2;
int POT_PIN_MIDDLE = A3;
int POT_PIN_LOWER = A4;

int SERVO_PIN_HAND = 9;
int SERVO_PIN_UPPER = 10;
int SERVO_PIN_MIDDLE = 6;
int SERVO_PIN_LOWER_RIGHT = 5;
int SERVO_PIN_LOWER_LEFT = 3;

// Declare servo object
Servo servo_hand;
Servo servo_upper;
Servo servo_middle;
Servo servo_lower_right;
Servo servo_lower_left;

void servoMove(int potVal, Servo servo, int reflect = 0) {
  int angle = 0;
  // The need for the reflection varied based on how the servo was mounted
  if (pos == 1) {
    angle = 180 - map(potVal, 0, 1023, 0, 180);
  }
  else {
    angle = map(potVal, 0, 1023, 0, 180);
  }
  servo.write(angle);
}

// Potentiometer resistance values
int pot_hand = 0;
int pot_upper = 0;
int pot_middle = 0;
int pot_lower = 0;

void setup() {
  Serial.begin(9600);  
  
  pinMode(POT_PIN_HAND, INPUT);
  pinMode(POT_PIN_UPPER, INPUT);
  pinMode(POT_PIN_MIDDLE, INPUT);
  pinMode(POT_PIN_LOWER, INPUT);
  
  pinMode(SERVO_PIN_HAND, OUTPUT);
  pinMode(SERVO_PIN_UPPER, OUTPUT);
  pinMode(SERVO_PIN_MIDDLE, OUTPUT);
  pinMode(SERVO_PIN_LOWER_RIGHT, OUTPUT);
  pinMode(SERVO_PIN_LOWER_LEFT, OUTPUT);

  servo_hand.attach(SERVO_PIN_HAND);
  servo_upper.attach(SERVO_PIN_UPPER);
  servo_middle.attach(SERVO_PIN_MIDDLE);
  servo_lower_right.attach(SERVO_PIN_LOWER_RIGHT);
  servo_lower_left.attach(SERVO_PIN_LOWER_LEFT);
}

void loop() {
  // Reading potentiometer values
  pot_hand = analogRead(POT_PIN_HAND);
  pot_upper = analogRead(POT_PIN_UPPER);
  pot_middle = analogRead(POT_PIN_MIDDLE);
  pot_lower = analogRead(POT_PIN_LOWER);

  // Call servoMove function for each servo
  servoMove(pot_hand, servo_hand, 0);
  servoMove(pot_upper, servo_upper, 0);
  servoMove(pot_middle, servo_middle, 0);
  servoMove(pot_lower, servo_lower_right, 1);
  servoMove(pot_lower, servo_lower_left, 1);
  
  delay(15);
}
